<?php
    /**
    * @package mod-autoview
    * @category mod
    * @author Tim Williams (EuroMotor/AutoTrain)
    * @licence This code is copyright to EuroMotor AutoTrain LLP and is licenced under the GNU GPL Licence
    */

    /**
    * Includes and requires
    */
    include_once('refmovie.inc.php' );
    require_once("../../config.php");

    $l     = optional_param('l',0,PARAM_INT);     // Autoview ID
    $qturl = required_param('qturl', PARAM_TEXT);

    if (! $autoview = get_record('autoview', 'id', $l)) {
       error("Course module is incorrect");
    }
    if (! $course = get_record('course', 'id', $autoview->course)) {
       error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance('autoview', $autoview->id, $course->id)) {
       error("Course Module ID was incorrect");
    }

    require_login($course->id);

    global $CFG, $THEME; // Useless

    $refMovie = new QTRefMovie();

    $dataReference = new QTDataReference($qturl);
    //$DataRate = new QTDataRate( "56k modem" );
    //$CPUSpeed = new QTCPUSpeed( "medium" );
    $movieDescriptor = new QTRefMovieDescriptor();
    $movieDescriptor->addChunk( $dataReference );
    //$movieDescriptor->addChunk( $DataRate );
    //$movieDescriptor->addChunk( $CPUSpeed );
    
    $RefMovie->addChunk( $movieDescriptor );
    
    $movie = new QTMovie();
    $movie->addChunk( $refMovie );
    
    header( 'Content-type: video/quicktime' );
    
    echo $movie->toString();
?>