<?PHP 
    /**
    * This page allows testing availability of mandatory components for the Autoview module to operate.
    * @package mod-autoview
    * @category mod
    * @author Tim Williams (EuroMotor/AutoTrain)
    * @licence This code is copyright to EuroMotor AutoTrain LLP and is licenced under the GNU GPL Licence
    */

    require_once("../../config.php");
    require_once("lib.php");
    
    $fileloc = $CFG->dirroot.'/mod/autoview/';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "DTD/xhtml1-frameset.dtd">
<html>
    <head>
        <title>AutoView Resource Test Page</title>  
    </head>
    <body>
        <h2>XSL Support</h2>
        <pre>
<?php

    $found = false;
    
    if (class_exists('XSLTProcessor')){
        $found = true;
        echo "PHP5 libxslt XSLTProcessor Found\n"; 
    
        if (method_exists('XSLTProcessor', 'importStyleSheet')){
            echo "\tXSLTProcessor->importStyleSheet() OK\n";
        } else {
            echo "\tXSLTProcessor->importStyleSheet() not found\n";
        }
    
        if (method_exists('XSLTProcessor', 'setParameter')){
            echo "\tXSLTProcessor->setParameter() OK\n";
        } else {
            echo "\tXSLTProcessor->setParameter() not found\n";
        }
       
        if (method_exists('XSLTProcessor', 'transformToXML')){
            echo "\tXSLTProcessor->transformToXML() OK\n";
        } else {
            echo "\tXSLTProcessor->transformToXML() not found\n";
        }
    
        if (class_exists('DOMDocument')){
            echo "\tDOMDocument OK\n";
        } else {
            echo "\tDOMDocument not found\n";
        }
    
        if (method_exists('DOMDocument', 'load')){
            echo "\tDOMDocument->load() OK\n";
        } else {
            echo "\tDOMDocument->load() not found\n";
        }
    }
    
    if (function_exists('xslt_create')) {
        $found = true;
        echo "\nPHP4 Sablot XSLT Found"."\n\t"."xslt_create() OK\n";
    
        if (function_exists('xslt_process')){
            echo "\txslt_process() OK\n";
        } else {
            echo "\txslt_process() not found\n";
        }
    
        if (function_exists('xslt_free')){
            echo "\txslt_free() OK\n";
        } else {
            echo "\txslt_free() not found\n";
        }
    }
    
    if (function_exists('domxml_xslt_stylesheet_file')) {
        $found = true;
        echo "\nPHP4 libxslt methods found"."\n\t"."domxml_xslt_stylesheet_file OK\n";
    
        if (function_exists('domxml_open_file')){
            echo "\tdomxml_open_file OK\n";
        } else {
            echo "\tdomxml_open_file not found\n";
        }
    }
?>
        </pre>
<?php
    if ($found == false){
        echo "<p><font color='#ff0000#'>Warning : No XSLT Processors have been found</font></p>";
    }
 ?>
        <h2>Check all module files :</h2>
        <table>
<?php
    $filename = $fileloc.'filelist.txt';
    $handle = fopen($filename, "r");
    $contents = fread($handle, filesize($filename));
    fclose($handle);
    
    $tok = strtok($contents, " \n\t");
    
    while ($tok !== false) {
        if (is_readable($fileloc.$tok))
            echo "<tr><td>".$tok."</td><td>OK</td></tr>\n";
        } elseif (file_exists($fileloc.$tok)) {
            echo "<tr><td bgcolor='#ff0000'>".$tok."</td><td bgcolor='#ff0000'>Unreadable</td>";
        } else {
         echo "<tr><td bgcolor='#ff0000'>".$tok."</td><td bgcolor='#ff0000'>Not Found</td>";
        }
    
        $tok = strtok("\n\r");
    }
       
?>
        </table>
    </body>
</html>